///////////////
//TommyGun.cs//
///////////////

//Script by Amade
//Model by Absolution

datablock AudioProfile(TommyGunShotSound)
{
   filename	= "./fire.wav";
   description	= AudioClose3d;
   preload	= true;
};

AddDamageType("TommyGun",
'<bitmap:add-ons/Weapon_TommyGun/TommyGun_CI> %1', //Suicide message
'%2 <bitmap:add-ons/Weapon_TommyGun/TommyGun_CI> %1',0.2,1); //Kill message

datablock ProjectileData(TommyGunProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 8;
   directDamageType    = $DamageType::TommyGun;
   radiusDamageType    = $DamageType::TommyGun;

   brickExplosionRadius			= 0;
   brickExplosionImpact			= true;
   brickExplosionForce			= 10;  //Brick damage
   brickExplosionMaxVolume		= 2;
   brickExplosionMaxVolumeFloating	= 3;

   impactImpulse	= 100; //How far back the bullet knocks you
   verticalImpulse	= 10;  //How far up the bullet knocks you
   explosion		= gunExplosion;
   particleEmitter	= ""; //Trail

   muzzleVelocity	= 135; //The speed of the bullet
   velInheritFactor	= 1;

   armingDelay		= 0;
   lifetime		= 4000;
   fadeDelay		= 3500;
   bounceElasticity	= 0.5;
   bounceFriction	= 0.20;
   isBallistic		= false;
   gravityMod		= 0.0;

   hasLight	= false;
   lightRadius	= 3.0;
   lightColor	= "0 0 0.5";
};

datablock ItemData(TommyGunItem)
{
	category	= "Weapon";
	className	= "Weapon";

	shapeFile	= "./TommyGun.dts";
	rotate		= false;
	mass		= 1;
	density		= 0.2; //How well does it float?
	elasticity	= 0.2; //How well does it bounce?
	friction	= 0.6; //More bounce
	emap		= true; //Dunno what this does

	uiName		= "Tommy Gun";
	iconName	= "./TommyGun_Icon";
	doColorShift	= false;
	colorShiftColor	= "0 0 0 1";

	image	= TommyGunImage;
	canDrop	= true;
};

datablock ShapeBaseImageData(TommyGunImage)
{
   shapeFile = "./TommyGun.dts";
   emap = true;

   mountPoint	= 0; //That's the right hand
   offset	= "0 0 0";
   eyeOffset	= 0;
   rotation	= ("0 0 -1 90"); //The model is pointing to the right, rotate 90 degrees counter-clockwise

   correctMuzzleVector	= true;

   className	= "WeaponImage";

   item		= BowItem;
   ammo		= " ";
   projectile	= TommyGunProjectile;
   projectileType = Projectile;

   casing		= gunShellDebris; //Debris fire from the model's ejectPoint node.
   shellExitDir		= "1.0 1.3 0.8";
   shellExitOffset	= "0 0 0"; //No offset, the model has an ejectPoint
   shellExitVariance	= 15.0;	
   shellVelocity	= 7.0;

   melee	= false;
   armReady	= true;

   doColorShift = false;
   colorShiftColor = "0 0 0 1";

	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.15;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]		= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.075;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= TommyGunShotSound;
	stateEjectShell[2]		= true;

	stateName[3]			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.5;
	stateEmitterNode[3]		= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Ready";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]	= "Smoke";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateSequence[4]		= "Ready";
};

function TommyGunImage::onFire(%this,%obj,%slot)
{
	%projectile = %this.projectile;
	%spread = 0.00175;

		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread; //I almost understand this thing now
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	return %p;
}
//That's the end, hope you liked it